; tabstop=8
;
;
;     +-------------+       +------+             +---
;     |             |       |      |             |
; ----+             +-------+      +-------------+
;
; ----------+----------+-------+------+---------------
;           |          |       |      |
; ----------+----------+-------+------+---------------
;
;      | TA |       |TB|    |TB|   |TB|
;
;      |    TC      |  TC   |  TC  |  |    TD    |
;
;  TA=`80us TB=`30us
;  TC=180usȉɂ
;  TD=300usȏɂ


MAX_X:		EQU	248
MAX_Y:		EQU	184
PAGE_OFFSET:	EQU	0E200H

	ORG	0D800H

START:
		; AY-3-8910 ̃|[gݒ
	LD	A,07H
	OUT	(0A0H),A
	LD	A,0BFH
	OUT	(0A1H),A	; |[g`́A|[gao͂ɐݒ

	LD	A,0FH
	OUT	(0A0H),A
	LD	A,0C0H
	OUT	(0A1H),A	; 6,7 pin ̓[hɐݒ / JOY1 I / 8pin (STROBE)  L o

LOOP:
		; `ԂÎ҂
LOOP1:	CALL	SYNCDET		; `Ԃ̎AZflag != 0
	JR	Z,LOOP1
LOOP2:	CALL	SYNCDET		; `Ԃ̎AZflag != 0
	JR	NZ,LOOP2
		;		
		;		ɗ鎞A`ԂI
		;

	DI

	LD	A,0FH
	OUT	(0A0H),A
	LD	A,0E0H
	OUT	(0A1H),A	; JOY1 I / 8pin (STROBE)  H o

		; ԑ҂i80 us = 320 clkj
	LD	A,12H		; 7+1
WAIT1:	DEC	A		; 4+1
	JR	NZ,WAIT1	; 12+1 / 7+1

		; }EXf[^́iwʂSrbg JOY1j
	LD	A,0EH
	OUT	(0A0H),A
	IN	A,(0A2H)
	LD	(M1_XH),A

	LD	A,0FH
	OUT	(0A0H),A
	LD	A,0C0H
	OUT	(0A1H),A	; JOY1 I / 8pin (STROBE)  L o

		; ԑ҂i30 us = 120 clkj
	LD	A,07H		; 7+1
WAIT2:	DEC	A		; 4+1
	JR	NZ,WAIT2	; 12+1 / 7+1

		; }EXf[^́iwʂSrbg JOY1j
	LD	A,0EH
	OUT	(0A0H),A
	IN	A,(0A2H)
	LD	(M1_XL),A

	LD	A,0FH
	OUT	(0A0H),A
	LD	A,0E0H
	OUT	(0A1H),A	; JOY1 I / 8pin (STROBE)  H o

		; ԑ҂i30 us = 120 clkj
	LD	A,07H		; 7+1
WAIT3:	DEC	A		; 4+1
	JR	NZ,WAIT3	; 12+1 / 7+1

		; }EXf[^́ixʂSrbg JOY1j
	LD	A,0EH
	OUT	(0A0H),A
	IN	A,(0A2H)
	LD	(M1_YH),A

	LD	A,0FH
	OUT	(0A0H),A
	LD	A,0C0H
	OUT	(0A1H),A	; JOY1 I / 8pin (STROBE)  L o


		; ԑ҂i30 us = 120 clkj
	LD	A,07H		; 7+1
WAIT4:	DEC	A		; 4+1
	JR	NZ,WAIT4	; 12+1 / 7+1

		; }EXf[^́ixʂSrbg JOY1j
	LD	A,0EH
	OUT	(0A0H),A
	IN	A,(0A2H)
	LD	(M1_YL),A

	EI

		; `Iʒu܂ő҂ih~j
LOOP3:	CALL	SYNCDET		; `Ԃ̎AZflag != 0
	JR	Z,LOOP3
LOOP4:	CALL	SYNCDET		; `Ԃ̎AZflag != 0
	JR	NZ,LOOP4
		;		
		;		ɗ鎞A`ԂI
		;

		; J[\
	LD	BC,(P_X)
	LD	DE,(P_Y)
	CALL	CALCADD

	CALL	CLEAR_PAT


		; VWZo
	LD	BC,(M1_XH)
	LD	DE,MAX_X
	LD	HL,(P_X)
	CALL	CALCPOINT
	LD	(P_X),HL

	LD	BC,(M1_YH)
	LD	DE,MAX_Y
	LD	HL,(P_Y)
	CALL	CALCPOINT
	LD	(P_Y),HL

		; J[\`
	LD	BC,(P_X)
	LD	DE,(P_Y)
	CALL	CALCADD

	LD	DE,CURSOR_PAT
	CALL	DRAW_PAT


	LD	A,(M1_YL)
	AND	30H		; }EX{^𗼕H
	JP	NZ,LOOP

	RET


SYNCDET:
	DI

	LD	B,04H
	LD	C,00H

	LD	A,08H
	OUT	(093H),A
LP1:	IN	A,(092H)
	RLCA
	JR	NC,LP1

LP2:
	LD	A,0FEH		; 7+1	/ ڍs 147
	OUT	(090H),A	; 7+1	/ ڍs 155
				; 4	/ o 4

	PUSH	HL		; 11+1	/ o 16
	POP	HL		; 10+1	/ o 27
	NOP			; 4+1	/ o 32
	NOP			; 4+1	/ o 37
	NOP			; 4+1	/ o 42

	IN	A,(092H)	; 7+1	/ o 50
				; 4	/ ڍs 4

	OR	C		; 4+1	/ ڍs 9
	LD	C,A		; 4+1	/ ڍs 14 

	PUSH	HL		; 11+1	/ o 26
	POP	HL		; 10+1	/ o 37
	PUSH	HL		; 11+1	/ o 49
	POP	HL		; 10+1	/ o 60
	PUSH	HL		; 11+1	/ o 72
	INC	HL		; 6+1	/ o 79
	DEC	HL		; 6+1	/ o 86
	INC	HL		; 6+1	/ o 93
	DEC	HL		; 6+1	/ o 100
	INC	HL		; 6+1	/ o 107
	DEC	HL		; 6+1	/ o 114
	POP	HL		; 10+1	/ o 125

	DJNZ	LP2		; 13+1	/ ڍs 139

	LD	A,09H
	OUT	(093H),A

	LD	A,C
	AND	80H

	EI
	RET


CLEAR_PAT:
		; p^[NA
		; HL:VRAMAhX

	LD	B,08H
	XOR	A
	LD	DE,31
CP_LP1:
	LD	(HL),A
	INC	HL
	LD	(HL),A
	ADD	HL,DE

	DJNZ	CP_LP1
	RET


DRAW_PAT:
		; p^[`悷
		; DE:p^[AhX
		; HL:VRAMAhX
		; A :p^[ԍ

	ADD	A,A		; x2
	ADD	A,A		; x4
	ADD	A,A		; x8
	ADD	A,A		; x16
	ADD	A,E
	LD	E,A
	LD	A,00H
	ADC	A,D
	LD	D,A

	LD	B,08H
DP_LP1:	PUSH	BC

	LD	A,(DE)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	LD	(HL),A
	INC	DE
	LD	BC,31
	ADD	HL,BC

	POP	BC
	DJNZ	DP_LP1
	RET


CALCADD:
		; WVRAMAhXZo
		; BC:wW
		; DE:xW
		; return : HL:AhX
		; return : A :]rbg

	LD	H,D
	LD	L,E

	ADD	HL,HL		; x2
	ADD	HL,HL		; x4
	ADD	HL,HL		; x8
	ADD	HL,HL		; x16
	ADD	HL,HL		; x32

	LD	E,C

	OR	A
	RR	B
	RR	C		; /2
	OR	A
	RR	B
	RR	C		; /4
	OR	A
	RR	B
	RR	C		; /8

	ADD	HL,BC

	LD	A,E
	AND	07H

	LD	DE,PAGE_OFFSET
	ADD	HL,DE

	RET


CALCPOINT:
		; J[\AVWZo
		; C:ʂSrbg / B:ʂSrbg
		; DE:W̍ől
		; HL:݂̍W
		; return : HL:VW

	LD	A,C
	RLCA
	RLCA
	RLCA
	RLCA
	AND	0F0H
	LD	C,A
	LD	A,B
	AND	0FH
	OR	C		; A <= t(8bit)
	NEG			; 𔽓]

	LD	C,A
	RLCA
	SBC	A,A
	LD	B,A		; BC <= t(16bit)


		; VWZoiwWj
	ADD	HL,BC
	EX	HL,DE		; DE <= VW;HL <= W̍ől

	LD	B,H
	LD	C,L

	OR	A
	SBC	HL,DE
	EX	HL,DE		; HL <= VW
	RET	NC

	RLC	H
	LD	HL,0000H
	RET	C

	LD	H,B
	LD	L,C
	RET



P_X:	DW	0000H
P_Y:	DW	0000H
M1_XH:	DB	00H
M1_XL:	DB	00H
M1_YH:	DB	00H
M1_YL:	DB	00H


CURSOR_PAT:
	DB	0F0H,000H,0C0H,000H,0A0H,000H,090H,000H,008H,000H,004H,000H,002H,000H,001H,000H
	DB	078H,000H,060H,000H,050H,000H,048H,000H,004H,000H,002H,000H,001H,000H,000H,080H
	DB	03CH,000H,030H,000H,028H,000H,024H,000H,002H,000H,001H,000H,000H,080H,000H,040H
	DB	01EH,000H,018H,000H,014H,000H,012H,000H,001H,000H,000H,080H,000H,040H,000H,020H
	DB	00FH,000H,00CH,000H,00AH,000H,009H,000H,000H,080H,000H,040H,000H,020H,000H,010H
	DB	007H,080H,006H,000H,005H,000H,004H,080H,000H,040H,000H,020H,000H,010H,000H,008H
	DB	003H,0C0H,003H,000H,002H,080H,002H,040H,000H,020H,000H,010H,000H,008H,000H,004H
	DB	001H,0E0H,001H,080H,001H,040H,001H,020H,000H,010H,000H,008H,000H,004H,000H,002H

